import {ComponentType} from 'react';
import {useState, useEffect} from 'react';
import {Route, Link, generatePath} from 'react-router-dom';

const routes = {

}

export const NamedRoute = ({name, routeName, query, pendingQueryComponent:P, errorQueryComponent:E, errorQueryComponentErrorProp="error", componentQueryResultProp='data', path, component, render, ...props}) => {
    name  ||= routeName
    routes[name || path] = {...props, path}

    const Render:ComponentType = component || render 

    const ComponentWrapper = (props) => {
        const [queryResult, setQueryResult] = useState()
        const [queryError, setQueryError] = useState()
        useEffect(() => {
            if (query && typeof query === 'function'){
                const querySyncResult = query(props.match.params, props, name)
                if (querySyncResult && typeof querySyncResult.then === 'function'){
                    querySyncResult.then(setQueryResult, setQueryError)
                }
                else {
                    setQueryResult(querySyncResult)
                }
            }
            return () => {
                setQueryError()
                setQueryResult()
            }
        },[props])

        if (!query || typeof query !== 'function')
            return <Render {...{[componentQueryResultProp]:query, ...props}} />

        if (!queryResult && !queryError)
            return P ? <P {...props} /> : null

        if (queryError)
            return E ? <E {...{[errorQueryComponentErrorProp]: queryError, ...props}} /> : null

        console.log({[componentQueryResultProp]:queryResult, ...props})

        return <Render {...{[componentQueryResultProp]:queryResult, ...props}} />
    }

    return <Route {...props} path={path}  component={ComponentWrapper}/>
}

export const NamedLink = ({routeName, params, to,...props}) => {
    const route = routes[routeName]
    if (route && !to){
        const pattern = route.path
        to            = generatePath(pattern, params)
    }
    return <Link to={to} {...props} />
}


